redi::pstream_common< CharT, Traits > Class Template Referenceabstract

Class template for common base class. More...

`#include <pstream.h>`

Inheritance diagram for redi::pstream_common< CharT, Traits >:

## Public Types

typedef int | fd_type
| Type used for file descriptors.

## Public Member Functions

void | close ()
| Close the pipe. More...
bool | is_open () const
| Report whether the stream's buffer has been initialised. More...
const std::string & | command () const
| Return the command used to initialise the stream. More...
streambuf_type * | rdbuf () const
| Return a pointer to the stream buffer. More...

## Static Public Attributes

static const pmode | pstdin = std::ios_base::out
| Write to stdin.
static const pmode | pstdout = std::ios_base::in
| Read from stdout.
static const pmode | pstderr = std::ios_base::app
| Read from stderr.

## Protected Types

typedef basic_pstreambuf < CharT, Traits > | streambuf_type
typedef pstreams::pmode | pmode
typedef pstreams::argv_type | argv_type
enum | { bufsz = 32 }
enum | { pbsz = 2 }

## Protected Member Functions

| pstream_common ()
| Default constructor. More...
| pstream_common (const std::string &command, pmode mode)
| Constructor that initialises the stream by starting a process. More...
| pstream_common (const std::string &file, const argv_type &argv, pmode mode)
| Constructor that initialises the stream by starting a process. More...
virtual | ~pstream_common ()=0
| Pure virtual destructor. More...
void | do_open (const std::string &command, pmode mode)
| Start a process. More...
void | do_open (const std::string &file, const argv_type &argv, pmode mode)
| Start a process. More...

## Protected Attributes

std::string | command_
| The command used to start the process.
streambuf_type | buf_
| The stream buffer.

## Detailed Description

### template<typename CharT, typename Traits = std::char_traits<CharT>>
class redi::pstream_common< CharT, Traits >

Class template for common base class.

Abstract Base Class providing common functionality for basic_ipstream, basic_opstream and basic_pstream. pstream_common manages the basic_pstreambuf stream buffer that is used by the derived classes to initialise an iostream class.

## Constructor & Destructor Documentation

template<typename C , typename T >

redi::pstream_common< C, T >::pstream_common | ( |  | ) |

inline protected

Default constructor.

Creates an uninitialised stream.

References redi::pstream_common< CharT, Traits >::buf_.

template<typename C , typename T >

redi::pstream_common< C, T >::pstream_common | ( | const std::string & | command,
|  | pmode | mode
| ) |  |

inline protected

Constructor that initialises the stream by starting a process.

Initialises the stream buffer by calling do_open( command , mode )

Parameters

  command | a string containing a shell command.
  mode | the I/O mode to use when opening the pipe.

See Also
  do_open(const std::string&, pmode)

References redi::pstream_common< CharT, Traits >::buf_, and redi::pstream_common< CharT, Traits >::do_open().

template<typename C , typename T >

redi::pstream_common< C, T >::pstream_common | ( | const std::string & | file,
|  | const argv_type & | argv,
|  | pmode | mode
| ) |  |

inline protected

Constructor that initialises the stream by starting a process.

Initialises the stream buffer by calling do_open( file , argv , mode )

Parameters

  file | a string containing the pathname of a program to execute.
  argv | a vector of argument strings passed to the new program.
  mode | the I/O mode to use when opening the pipe.

See Also
  do_open(const std::string&, const argv_type&, pmode)

References redi::pstream_common< CharT, Traits >::buf_, and redi::pstream_common< CharT, Traits >::do_open().

template<typename C , typename T >

redi::pstream_common< C, T >::~pstream_common | ( |  | ) |

inline protected pure virtual

Pure virtual destructor.

This is a pure virtual function to make `pstream_common` abstract. Because it is the destructor it will be called by derived classes and so must be defined. It is also protected, to discourage use of the PStreams classes through pointers or references to the base class.

See Also
  If defining a pure virtual seems odd you should read http://www.gotw.ca/gotw/031.htm (and the rest of the site as well!)

## Member Function Documentation

template<typename C , typename T >

void redi::pstream_common< C, T >::close | ( |  | ) |

inline

Close the pipe.

Calls rdbuf->close() and sets `failbit` on error.

template<typename C , typename T >

const std::string & redi::pstream_common< C, T >::command | ( |  | ) | const

inline

Return the command used to initialise the stream.

Returns
  a string containing the command used to initialise the stream.

template<typename C , typename T >

void redi::pstream_common< C, T >::do_open | ( | const std::string & | command,
|  | pmode | mode
| ) |  |

inline protected

Start a process.

Calls rdbuf()->open( command , mode ) and sets `failbit` on error.

Parameters

  command | a string containing a shell command.
  mode | the I/O mode to use when opening the pipe.

See Also
  basic_pstreambuf::open(const std::string&, pmode)

Referenced by redi::basic_ipstream< CharT, Traits >::open(), redi::basic_opstream< CharT, Traits >::open(), redi::basic_pstream< CharT, Traits >::open(), redi::basic_rpstream< CharT, Traits >::open(), and redi::pstream_common< CharT, Traits >::pstream_common().

template<typename C , typename T >

void redi::pstream_common< C, T >::do_open | ( | const std::string & | file,
|  | const argv_type & | argv,
|  | pmode | mode
| ) |  |

inline protected

Start a process.

Calls rdbuf()->open( file, argv, mode ) and sets `failbit` on error.

Parameters

  file | a string containing the pathname of a program to execute.
  argv | a vector of argument strings passed to the new program.
  mode | the I/O mode to use when opening the pipe.

See Also
  basic_pstreambuf::open(const std::string&, const argv_type&, pmode)

template<typename C , typename T >

bool redi::pstream_common< C, T >::is_open | ( |  | ) | const

inline

Report whether the stream's buffer has been initialised.

Returns
  rdbuf()->is_open().

See Also
  basic_pstreambuf::is_open()

template<typename C , typename T >

pstream_common< C, T >::streambuf_type * redi::pstream_common< C, T >::rdbuf | ( |  | ) | const

inline

Return a pointer to the stream buffer.

Returns
  a pointer to the private stream buffer member.

The documentation for this class was generated from the following file:

- pstream.h